Index: trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 2792)
+++ trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 2794)
@@ -1,225 +1,479 @@
-!
-! $Id $
-!
-SUBROUTINE pemetat0(fichnom,min_h2o_ice_s,min_co2_ice_s,iim_input,jjm_input,nlayer,vmr_co2_gcm,ps_GCM,timelen,min_co2_ice_slope,min_h2o_ice_slope,nslope)
-
-      use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
-                        nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
-                        nf90_inquire_dimension,nf90_close
-
-      IMPLICIT NONE
-
-!=======================================================================
-!
-! Read initial confitions file
-!
-!=======================================================================
-
-  include "dimensions.h"
-
-!===============================================================================
-! Arguments:
-
-! INPUT:
-  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
-
-  INTEGER :: iim_input,jjm_input,nlayer,nslope
-
-! LOCAL:
-
-  REAL, ALLOCATABLE ::  h2o_ice_s(:,:,:)                       ! h2o_ice_s of the concatenated file
-  REAL, ALLOCATABLE ::  co2_ice_s(:,:,:)                       ! co2_ice_s of the concatenated file
-
-  REAL, ALLOCATABLE ::  h2o_ice_s_slope(:,:,:,:)               ! h2o_ice_s slope of the concatenated file
-  REAL, ALLOCATABLE ::  co2_ice_s_slope(:,:,:,:)               ! co2_ice_s slope of the concatenated file
-
-  REAL, ALLOCATABLE ::  q_co2_GCM(:,:,:)                       ! vmr of co2 of the first layer in the GCM year
-
-! OUTPUT:
-
-  REAL, INTENT(OUT) ::  min_h2o_ice_s(iim_input+1,jjm_input+1) ! Minimum of h2o_ice_s of the year
-  REAL, INTENT(OUT) ::  min_co2_ice_s(iim_input+1,jjm_input+1) ! Minimum of co2_ice_s of the year
-
-  REAL, INTENT(OUT) ::  min_h2o_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
-  REAL, INTENT(OUT) ::  min_co2_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
-
-  REAL, INTENT(OUT) ::  vmr_co2_gcm(iim_input+1,jjm_input+1,2676)         ! vmr of co2 of the first layer in the GCM year
-
-  REAL,  INTENT(OUT) ::  ps_GCM(iim_input+1,jjm_input+1,2676)  ! Surface pressure in the GCM year
-
-!===============================================================================
-!   Local Variables 
-  CHARACTER(LEN=256) :: msg, var, modname
-  INTEGER,PARAMETER :: length=100
-  INTEGER :: iq, fID, vID, idecal
-  INTEGER :: ierr
-  CHARACTER(len=12) :: start_file_type="earth" ! default start file type
-
-  REAL,ALLOCATABLE :: time(:) ! times stored in start
-  INTEGER :: timelen ! number of times stored in the file
-  INTEGER :: indextime ! index of selected time
-
-  INTEGER :: edges(4),corner(4)
-  INTEGER :: i,j,t
-  real,save :: m_co2, m_noco2, A , B, mmean
-
-  INTEGER :: islope
-  CHARACTER*2 :: num
-
-
-!-----------------------------------------------------------------------
-  modname="pemetat0"
-
-      m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
-      m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
-      A =(1/m_co2 - 1/m_noco2)
-      B=1/m_noco2
-
-!  Open initial state NetCDF file
-  var=fichnom
-  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
-
-      ierr = nf90_inq_varid (fID, "temps", vID)
-      IF (ierr .NE. nf90_noerr) THEN
-        write(*,*)"pemetat0: Le champ <temps> est absent"
-        write(*,*)"pemetat0: J essaie <Time>"
-        ierr = nf90_inq_varid (fID, "Time", vID)
-        IF (ierr .NE. nf90_noerr) THEN
-           write(*,*)"pemetat0: Le champ <Time> est absent"
-           write(*,*)trim(nf90_strerror(ierr))
-           CALL ABORT_gcm("pemetat0", "", 1)
-        ENDIF
-        ! Get the length of the "Time" dimension
-        ierr = nf90_inq_dimid(fID,"Time",vID)
-        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
-      ELSE   
-        ! Get the length of the "temps" dimension
-        ierr = nf90_inq_dimid(fID,"temps",vID)
-        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
-      ENDIF
-
-      allocate(co2_ice_s(iim+1,jjm+1,timelen))
-      allocate(q_co2_GCM(iim+1,jjm+1,timelen))
-
-      allocate(co2_ice_s_slope(iim+1,jjm+1,nslope,timelen))
-      allocate(h2o_ice_s_slope(iim+1,jjm+1,nslope,timelen))
-
-
-
-! Get all the needed variable of the concatenated file
-  CALL get_var3("h2o_ice_s"   ,h2o_ice_s)
-  CALL get_var3("co2ice"   ,co2_ice_s)
-  CALL get_var3("co2_cropped"   ,q_co2_GCM)
-  CALL get_var3("ps"   ,ps_GCM)
-
-! Slope
+   SUBROUTINE pemetat0(startpem_file,filename,ngrid,nsoil_GCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM_yr1,tsoil_PEM,ice_table, &
+                      tsurf_ave_yr1,tsurf_ave,q_co2,q_h2o,ps_yr1_inst,ps_inst,tsurf_inst,tsoil_inst,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice, m_co2_regolith_phys,deltam_co2_regolith_phys)
+   
+   use iostart_PEM, only:  open_startphy, close_startphy, get_field 
+   use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,n_1km,fluxgeo,inertiedat_PEM
+   use comsoil_h, only:  volcapa,inertiedat 
+   use ini_soil_mod, only:  ini_icetable
+   use soil_evolution_mod, only: soil_pem_CN
+   use adsorption_mod, only : regolith_co2adsorption
+  implicit none
+
+ 
+  character(len=*), intent(in) :: filename
+  LOGICAL,intent(in) :: startpem_file
+  character*8 :: fichnom
+  integer,intent(in) :: ngrid
+  integer,intent(in) :: nsoil_GCM
+  integer,intent(in) :: nsoil_PEM
+  integer,intent(in) :: nslope
+  integer,intent(in) :: timelen
+  real, intent(in) :: tsurf_ave_yr1(ngrid,nslope)                          ! surface temperature at the first year of GCM call
+  real,intent(in) :: tsurf_ave(ngrid,nslope)                  ! surface temperature at the current year
+  real,intent(in) :: q_co2(ngrid,timelen)                     ! MMR tracer co2 [kg/kg]
+  real,intent(in) :: q_h2o(ngrid,timelen)                     ! MMR tracer h2o [kg/kg]
+  real,intent(in) :: ps_yr1_inst(ngrid,timelen)
+  real,intent(in) :: ps_inst(ngrid,timelen)                        ! surface pressure [Pa]
+  real,intent(in) :: tsurf_inst(ngrid,nslope,timelen) ! soil (mid-layer) temperature
+  real,intent(in) :: timestep	    ! time step
+  real,intent(in) :: tend_h2oglaciers(ngrid,nslope)
+  real,intent(in) :: tend_co2glaciers(ngrid,nslope)
+  real,intent(in) :: co2ice(ngrid,nslope)
+  real,intent(in) :: waterice(ngrid,nslope) 
+  real, intent(in) :: tsoil_PEM_yr1(ngrid,nsoil_PEM,nslope) 
+
+! outputs
+
+
+
+
+
+  real,intent(inout) :: TI_PEM(ngrid,nsoil_PEM,nslope) !soil (mid-layer) thermal inertia (SI)
+  real,intent(inout) :: tsoil_PEM(ngrid,nsoil_PEM,nslope) !soil (mid-layer) temperature (K)
+  real,intent(inout) :: ice_table(ngrid,nslope) ! (m)
+  real,intent(inout) :: tsoil_inst(ngrid,nsoil_PEM,nslope,timelen) ! instantaneous soil (mid-layer) temperature (k)
+  real,intent(inout) :: m_co2_regolith_phys(ngrid,nsoil_PEM,nslope)   ! mass of co2 adsorbed (kg/m^2)
+  real,intent(out) :: deltam_co2_regolith_phys(ngrid)                 ! mass of co2 that is exchanged due to adsorption desorption 
+! local
+   real :: tsoil_startPEM(ngrid,nsoil_PEM,nslope)
+   real :: TI_startPEM(ngrid,nsoil_PEM,nslope)
+   LOGICAL :: found
+   integer :: iloop,ig,islope,it,isoil
+   REAL :: TI_breccia = 750.
+   REAL :: TI_bedrock = 2300.
+   real :: kcond
+   real :: delta
+   CHARACTER*2 :: num
+   real :: tsoil_saved(ngrid,nsoil_PEM)
+   real :: tsoil_tmp_yr1(ngrid,nsoil_PEM,nslope)
+   real :: tsoil_tmp_yr2(ngrid,nsoil_PEM,nslope)
+   real :: tsoil_tmp(ngrid,nsoil_PEM,nslope)
+   real :: alph_tmp(nsoil_PEM-1)
+   real :: beta_tmp(nsoil_PEM-1)
+   real :: co2_ads_prev(ngrid) 
+   real :: ps_ave_yr1(ngrid)
+   real :: ps_ave_yr2(ngrid)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!
+!!! Purpose: read start_pem. Need a specific iostart_PEM
+!!!
+!!! Order: 1. Thermal Inertia 
+!!!        2. Soil Temperature
+!!!        3. Ice table
+!!!        4. Mass of CO2 adsorbed
+!!!
+!!! /!\ This order must be respected !
+!!! Author: LL
+!!!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+! 0. Some initializations
+ ps_ave_yr1(:) = sum(ps_yr1_inst(:,:),2)/timelen
+ ps_ave_yr2(:) = sum(ps_inst(:,:),2)/timelen
+
+!1. Run
+
+
+
+
+if (startpem_file) then
+   ! open pem initial state file:
+   call open_startphy(filename)
+ 
+!1. Thermal Inertia
+! a. General case
 
 DO islope=1,nslope
   write(num,fmt='(i2.2)') islope
-  call get_var3("co2ice_slope"//num,co2_ice_s_slope(:,:,islope,:))
-ENDDO
+  call get_field("TI_PEM_slope"//num,TI_startPEM(:,:,islope),found)
+   if(.not.found) then
+      write(*,*)'PEM settings: failed loading <TI_PEM_slope'//num//'>'
+      write(*,*)'will reconstruct the values of TI_PEM'
+
+      do ig = 1,ngrid
+
+          if(TI_PEM(ig,nsoil_GCM,islope).lt.TI_breccia) then 
+!!! transition
+             delta = 50.
+             TI_PEM(ig,nsoil_GCM+1,islope) = sqrt((layer_PEM(nsoil_GCM+1)-layer_PEM(nsoil_GCM))/ &
+            (((delta-layer_PEM(nsoil_GCM))/(TI_PEM(ig,nsoil_GCM,islope)**2))+ &
+                      ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
+
+          do iloop=nsoil_GCM+2,n_1km
+            TI_PEM(ig,iloop,islope) = TI_breccia
+         enddo      
+         else ! we keep the high ti values
+           do iloop=nsoil_GCM+1,n_1km
+                  TI_PEM(ig,iloop,islope) = TI_PEM(ig,nsoil_GCM,islope)
+           enddo 
+
+         endif ! TI PEM and breccia comparison
+
+
+!! transition
+             delta = 1000.
+             TI_PEM(ig,n_1km+1,islope) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
+            (((delta-layer_PEM(n_1km))/(TI_PEM(ig,n_1km,islope)**2))+ &
+                      ((layer_PEM(n_1km+1)-delta)/(TI_bedrock**2))))
+          do iloop=n_1km+2,nsoil_PEM
+            TI_PEM(ig,iloop,islope) = TI_bedrock
+         enddo   
+      enddo
+
+   else
+     do iloop = nsoil_GCM+1,nsoil_PEM
+       TI_PEM(:,iloop,islope) = TI_startPEM(:,iloop,islope)  ! ! 1st layers can change because of the presence of ice at the surface, so we don't change it here.
+     enddo
+   endif ! not found
+ENDDO ! islope
+
+print *,'PEMETAT0: THERMAL INERTIA DONE'
+
+
+
+! b. Special case for inertiedat, inertiedat_PEM
+call get_field("inertiedat_PEM",inertiedat_PEM,found)
+if(.not.found) then
+ do iloop = 1,nsoil_GCM
+   inertiedat_PEM(:,iloop) = inertiedat(:,iloop)
+ enddo
+
+  
+!!! zone de transition
+delta = 50.
+do ig = 1,ngrid
+if(inertiedat_PEM(ig,nsoil_GCM).lt.TI_breccia) then 
+inertiedat_PEM(ig,nsoil_GCM+1) = sqrt((layer_PEM(nsoil_GCM+1)-layer_PEM(nsoil_GCM))/ &
+            (((delta-layer_PEM(nsoil_GCM))/(inertiedat(ig,nsoil_GCM)**2))+ &
+                      ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
+
+
+ do iloop = nsoil_GCM+2,n_1km 
+       inertiedat_PEM(ig,iloop) = TI_breccia
+  enddo
+
+else
+   do iloop=nsoil_GCM+1,n_1km
+      inertiedat_PEM(ig,iloop) = inertiedat_PEM(ig,nsoil_GCM)
+   enddo 
+endif ! comparison ti breccia
+enddo!ig
+
+!!! zone de transition
+delta = 1000.
+do ig = 1,ngrid
+inertiedat_PEM(ig,n_1km+1) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
+            (((delta-layer_PEM(n_1km))/(inertiedat_PEM(ig,n_1km)**2))+ &
+                      ((layer_PEM(n_1km+1)-delta)/(TI_bedrock**2))))
+enddo
+
+
+
+ do iloop = n_1km+2, nsoil_PEM
+   do ig = 1,ngrid
+      inertiedat_PEM(ig,iloop) = TI_bedrock
+   enddo
+ enddo
+endif ! not found
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+!2. Soil Temperature
 
 DO islope=1,nslope
   write(num,fmt='(i2.2)') islope
-  call get_var3("h2o_ice_s_slope"//num,h2o_ice_s_slope(:,:,islope,:))
+   call get_field("tsoil_PEM_slope"//num,tsoil_startPEM(:,:,islope),found)
+  if(.not.found) then
+      write(*,*)'PEM settings: failed loading <tsoil_PEM_slope'//num//'>'
+      write(*,*)'will reconstruct the values of Tsoil'
+      do ig = 1,ngrid
+        kcond = (TI_PEM(ig,nsoil_GCM+1,islope)*TI_PEM(ig,nsoil_GCM+1,islope))/volcapa
+        tsoil_PEM(ig,nsoil_GCM+1,islope) = tsoil_PEM(ig,nsoil_GCM,islope) + fluxgeo/kcond*(mlayer_PEM(nsoil_GCM)-mlayer_PEM(nsoil_GCM-1))   
+
+       do iloop=nsoil_GCM+2,n_1km
+            kcond = (TI_PEM(ig,iloop,islope)*TI_PEM(ig,iloop,islope))/volcapa
+            tsoil_PEM(ig,iloop,islope) = tsoil_PEM(ig,nsoil_GCM+1,islope) + fluxgeo/kcond*(mlayer_PEM(iloop-1)-mlayer_PEM(nsoil_GCM))
+      enddo
+        kcond = (TI_PEM(ig,n_1km+1,islope)*TI_PEM(ig,n_1km+1,islope))/volcapa
+        tsoil_PEM(ig,n_1km+1,islope) = tsoil_PEM(ig,n_1km,islope) + fluxgeo/kcond*(mlayer_PEM(n_1km)-mlayer_PEM(n_1km-1))  
+
+       do iloop=n_1km+2,nsoil_PEM
+            kcond = (TI_PEM(ig,iloop,islope)*TI_PEM(ig,iloop,islope))/volcapa
+            tsoil_PEM(ig,iloop,islope) = tsoil_PEM(ig,n_1km+1,islope) + fluxgeo/kcond*(mlayer_PEM(iloop-1)-mlayer_PEM(n_1km))
+      enddo
+    enddo
+
+   else
+! predictor corrector: restart from year 1 of the GCM and build the evolution of
+! tsoil at depth
+
+    tsoil_tmp_yr1(:,:,islope) = tsoil_startPEM(:,:,islope)
+    call soil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
+    call soil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
+    tsoil_tmp_yr2(:,:,islope) = tsoil_tmp_yr1(:,:,islope)     
+    call soil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave(:,islope),tsoil_tmp_yr2(:,:,islope),alph_tmp,beta_tmp)
+
+
+     do iloop = nsoil_GCM+1,nsoil_PEM
+       tsoil_PEM(:,iloop,islope) = tsoil_tmp_yr2(:,iloop,islope)
+     enddo
+   endif
+
+    do it = 1,timelen
+        do isoil = nsoil_GCM+1,nsoil_PEM
+        tsoil_inst(:,isoil,islope,it) = tsoil_PEM(:,isoil,islope)
+        enddo
+     enddo
+
+
+
+    
 ENDDO
-
-! Compute the minimum over the year for each point
-  min_h2o_ice_s(:,:)=minval(h2o_ice_s,3)
-  min_co2_ice_s(:,:)=minval(co2_ice_s,3)
-
-  min_co2_ice_slope(:,:,:)=minval(co2_ice_s_slope,4)
-  min_h2o_ice_slope(:,:,:)=minval(h2o_ice_s_slope,4)
-
-! By definition, a density is positive, we get rid of the negative values
-  DO i=1,iim+1
-    DO j = 1, jjm+1
-       if (min_co2_ice_s(i,j).LT.0) then
-          min_h2o_ice_s(i,j)  = 0.
-          min_co2_ice_s(i,j)  = 0.
-       endif
-       DO islope=1,nslope
-          if (min_co2_ice_slope(i,j,islope).LT.0) then
-            min_co2_ice_slope(i,j,islope)  = 0.
-          endif
-          if (min_h2o_ice_slope(i,j,islope).LT.0) then
-            min_h2o_ice_slope(i,j,islope)  = 0.
-          endif
-       ENDDO
-    ENDDO
-  ENDDO
-
-! Compute the volume mixing ratio of co2 in the first layer
-
-  DO i=1,iim+1
-    DO j = 1, jjm+1
-      DO t = 1, timelen
-         if (q_co2_GCM(i,j,t).LT.0) then
-              q_co2_GCM(i,j,t)=1E-10
-         elseif (q_co2_GCM(i,j,t).GT.1) then
-              q_co2_GCM(i,j,t)=1.
+print *,'PEMETAT0: SOIL TEMP  DONE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+!3. Ice Table
+
+ 
+   call get_field("ice_table",ice_table,found)
+   if(.not.found) then
+      write(*,*)'PEM settings: failed loading <Ice Table>'
+      write(*,*)'will reconstruct the values of ice table'
+
+
+      call ini_icetable(timelen,ngrid,nsoil_PEM,TI_PEM, timestep,tsurf_ave(:,islope),tsoil_PEM(:,:,islope),tsurf_inst(:,islope,:),  tsoil_inst(:,:,islope,:),q_co2,q_h2o,ps_inst,ice_table(:,islope))
+
+
+   else 
+   ! update ice table
+     call computeice_table(timelen,ngrid,nslope,nsoil_PEM,tsoil_inst,tsurf_inst,q_co2,q_h2o, ps_inst, ice_table)
+
+
+   endif
+
+print *,'PEMETAT0: ICE TABLE  DONE'
+
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+!4. CO2 Adsorption
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+   call get_field("mco2_reg_ads_slope"//num,m_co2_regolith_phys(:,:,islope),found)
+   if(.not.found) then
+      write(*,*)'PEM settings: failed loading <m_co2_regolith_phys>'
+      write(*,*)'will reconstruct the values of co2 adsorbded'
+   m_co2_regolith_phys(:,:,:) = 0.
+   call regolith_co2adsorption(ngrid,nslope,nsoil_PEM,timelen,ps_inst,tsoil_PEM,TI_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,q_co2,q_h2o,m_co2_regolith_phys, deltam_co2_regolith_phys)
+
+   deltam_co2_regolith_phys(:) = 0.
+   exit
+   endif
+ENDDO
+
+if (found) then
+   DO iloop = 1,nsoil_GCM
+      tsoil_tmp_yr1(:,iloop,:) = tsoil_PEM_yr1(:,iloop,:)
+
+   ENDDO  
+
+   call regolith_co2adsorption(ngrid,nslope,nsoil_PEM,timelen,ps_inst,tsoil_PEM,TI_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,q_co2,q_h2o,m_co2_regolith_phys, deltam_co2_regolith_phys)
+
+
+endif
+print *,'PEMETAT0: CO2 adsorption done  '
+
+
+
+call close_startphy
+
+
+else !No startfi, let's build all by hand
+
+
+
+!a) Thermal inertia
+   do islope = 1,nslope
+      do ig = 1,ngrid
+
+          if(TI_PEM(ig,nsoil_GCM,islope).lt.TI_breccia) then 
+!!! transition
+             delta = 50.
+             TI_PEM(ig,nsoil_GCM+1,islope) =sqrt((layer_PEM(nsoil_GCM+1)-layer_PEM(nsoil_GCM))/ &
+            (((delta-layer_PEM(nsoil_GCM))/(TI_PEM(ig,nsoil_GCM,islope)**2))+ &
+                      ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
+
+          do iloop=nsoil_GCM+2,n_1km
+            TI_PEM(ig,iloop,islope) = TI_breccia
+         enddo      
+         else ! we keep the high ti values
+           do iloop=nsoil_GCM+1,n_1km
+                  TI_PEM(ig,iloop,islope) = TI_PEM(ig,nsoil_GCM,islope)
+           enddo 
+
          endif
-         mmean=1/(A*q_co2_GCM(i,j,t) +B)
-         vmr_co2_gcm(i,j,t) = q_co2_GCM(i,j,t)*mmean/m_co2
+
+
+!! transition
+             delta = 1000.
+             TI_PEM(ig,n_1km+1,islope) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
+            (((delta-layer_PEM(n_1km))/(TI_PEM(ig,n_1km,islope)**2))+ &
+                      ((layer_PEM(n_1km+1)-delta)/(TI_breccia**2))))
+          do iloop=n_1km+2,nsoil_PEM
+            TI_PEM(ig,iloop,islope) = TI_bedrock
+         enddo   
+      enddo
+
+enddo
+
+
+ do iloop = 1,nsoil_GCM
+   inertiedat_PEM(:,iloop) = inertiedat(:,iloop)
+ enddo
+!!! zone de transition
+delta = 50.
+do ig = 1,ngrid
+      if(inertiedat_PEM(ig,nsoil_GCM).lt.TI_breccia) then 
+inertiedat_PEM(ig,nsoil_GCM+1) = sqrt((layer_PEM(nsoil_GCM+1)-layer_PEM(nsoil_GCM))/ &
+            (((delta-layer_PEM(nsoil_GCM))/(inertiedat(ig,nsoil_GCM)**2))+ &
+                      ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
+
+
+ do iloop = nsoil_GCM+2,n_1km 
+
+       inertiedat_PEM(ig,iloop) = TI_breccia
+   
+ enddo
+else 
+   do iloop = nsoil_GCM+1,n_1km 
+       inertiedat_PEM(ig,iloop) = inertiedat_PEM(ig,nsoil_GCM)
+    enddo
+
+endif
+enddo
+
+
+!!! zone de transition
+delta = 1000.
+do ig = 1,ngrid
+inertiedat_PEM(ig,n_1km+1) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
+            (((delta-layer_PEM(n_1km))/(inertiedat_PEM(ig,n_1km)**2))+ &
+                      ((layer_PEM(n_1km+1)-delta)/(TI_bedrock**2))))
+enddo
+
+
+
+ do iloop = n_1km+2, nsoil_PEM
+   do ig = 1,ngrid
+      inertiedat_PEM(ig,iloop) = TI_bedrock
+   enddo
+ enddo
+
+print *,'PEMETAT0: TI  DONE'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+!b) Soil temperature 
+    do islope = 1,nslope
+
+     write(*,*) "islope=",islope
+     do ig = 1,ngrid
+        kcond = (TI_PEM(ig,nsoil_GCM+1,islope)*TI_PEM(ig,nsoil_GCM+1,islope))/volcapa
+        tsoil_PEM(ig,nsoil_GCM+1,islope) = tsoil_PEM(ig,nsoil_GCM,islope) + fluxgeo/kcond*(mlayer_PEM(nsoil_GCM)-mlayer_PEM(nsoil_GCM-1))
+
+       do iloop=nsoil_GCM+2,n_1km
+            kcond = (TI_PEM(ig,iloop,islope)*TI_PEM(ig,iloop,islope))/volcapa
+            tsoil_PEM(ig,iloop,islope) = tsoil_PEM(ig,nsoil_GCM+1,islope) + fluxgeo/kcond*(mlayer_PEM(iloop-1)-mlayer_PEM(nsoil_GCM))
+      enddo
+        kcond = (TI_PEM(ig,n_1km+1,islope)*TI_PEM(ig,n_1km+1,islope))/volcapa
+        tsoil_PEM(ig,n_1km+1,islope) = tsoil_PEM(ig,n_1km,islope) + fluxgeo/kcond*(mlayer_PEM(n_1km)-mlayer_PEM(n_1km-1))
+
+       do iloop=n_1km+2,nsoil_PEM
+            kcond = (TI_PEM(ig,iloop,islope)*TI_PEM(ig,iloop,islope))/volcapa
+            tsoil_PEM(ig,iloop,islope) = tsoil_PEM(ig,n_1km+1,islope) + fluxgeo/kcond*(mlayer_PEM(iloop-1)-mlayer_PEM(n_1km))
+      enddo
+!     write(*,*) "ig, islope, T=", ig,islope,tsoil_PEM(ig,:,islope)
+     enddo
+    
+    do it = 1,timelen
+        do isoil = nsoil_GCM+1,nsoil_PEM
+        tsoil_inst(:,isoil,islope,it) = tsoil_PEM(:,isoil,islope)
+        enddo
+     enddo
+enddo
+print *,'PEMETAT0: TSOIL DONE  '
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!c) Ice table    
+      do islope = 1,nslope
+      call ini_icetable(timelen,ngrid,nsoil_PEM,TI_PEM, timestep,tsurf_ave(:,islope),tsoil_PEM(:,:,islope),tsurf_inst(:,islope,:), &  
+       tsoil_inst(:,:,islope,:),q_co2,q_h2o,ps_inst,ice_table(:,islope))
+      enddo
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+print *,'PEMETAT0: Ice table DONE  '
+
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!d) Regolith adsorbed
+
+   m_co2_regolith_phys(:,:,:) = 0.
+   call regolith_co2adsorption(ngrid,nslope,nsoil_PEM,timelen,ps_inst,tsoil_PEM,TI_PEM,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice,q_co2,q_h2o,m_co2_regolith_phys, deltam_co2_regolith_phys)
+   deltam_co2_regolith_phys(:) = 0.
+
+print *,'PEMETAT0: CO2 adsorption done  '
+
+
+
+
+
+
+
+
+
+
+endif ! of if (startphy_file)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    DO ig = 1,ngrid
+      DO islope = 1,nslope
+
+     write(*,*) 'ig,islope ,ice table=',ig,islope,ice_table(ig,islope)
+
       ENDDO
     ENDDO
-  ENDDO
-
-
-
-
-
-
-  CONTAINS
-
-SUBROUTINE check_dim(n1,n2,str1,str2)
-  INTEGER,          INTENT(IN) :: n1, n2
-  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
-  CHARACTER(LEN=256) :: s1, s2
-  IF(n1/=n2) THEN
-    s1='value of '//TRIM(str1)//' ='
-    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
-    WRITE(msg,'(10x,a,i4,2x,a,i4)')TRIM(s1),n1,TRIM(s2),n2
-    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
-  END IF
-END SUBROUTINE check_dim
-
-
-SUBROUTINE get_var1(var,v)
-  CHARACTER(LEN=*), INTENT(IN)  :: var
-  REAL,             INTENT(OUT) :: v(:)
-  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
-  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
-END SUBROUTINE get_var1
-
-
-SUBROUTINE get_var3(var,v) ! on U grid
-  CHARACTER(LEN=*), INTENT(IN)  :: var
-  REAL,             INTENT(OUT) :: v(:,:,:)
-  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
-  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
-
-END SUBROUTINE get_var3
-
-SUBROUTINE get_var4(var,v) 
-  CHARACTER(LEN=*), INTENT(IN)  :: var
-  REAL,             INTENT(OUT) :: v(:,:,:,:)
-  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
-  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
-END SUBROUTINE get_var4
-
-SUBROUTINE err(ierr,typ,nam)
-  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
-  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
-  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
-  IF(ierr==NF90_NoERR) RETURN
-  SELECT CASE(typ)
-    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
-    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
-    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
-    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
-  END SELECT
-  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
-END SUBROUTINE err
-
-END SUBROUTINE pemetat0
+
+
+
+!! small test
+    DO ig = 1,ngrid
+      DO islope = 1,nslope
+        DO iloop = 1,nsoil_PEM
+           if(isnan(tsoil_PEM(ig,iloop,islope))) then 
+         write(*,*) "failed nan construction", ig, iloop, islope
+           stop
+           endif
+        ENDDO
+      ENDDO
+     ENDDO
+
+      write(*,*) "construction ok, no nan" 
+     
+
+   END SUBROUTINE
Index: trunk/LMDZ.COMMON/libf/evolution/pemredem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 2794)
@@ -0,0 +1,126 @@
+module pemredem
+
+implicit none
+
+contains
+
+subroutine pemdem0(filename,lonfi,latfi,cell_area,nsoil_PEM,ngrid, &
+                         day_ini,time,nslope,def_slope,subslope_dist)
+! create physics restart file and write time-independent variables
+!  use comsoil_h, only: inertiedat, volcapa, mlayer
+  use comsoil_h_PEM, only: mlayer_PEM,fluxgeo,inertiedat_PEM
+  use iostart_PEM, only : open_restartphy, close_restartphy, & 
+                      put_var, put_field, length
+  use mod_grid_phy_lmdz, only : klon_glo
+  use planete_h, only: aphelie, emin_turb, lmixmin, obliquit, &
+                       peri_day, periheli, year_day
+  use comcstfi_h, only: g, mugaz, omeg, rad, rcp
+  use time_phylmdz_mod, only: daysec
+  implicit none
+ 
+  character(len=*), intent(in) :: filename
+  real,intent(in) :: lonfi(ngrid)
+  real,intent(in) :: latfi(ngrid)
+  integer,intent(in) :: nsoil_PEM
+  integer,intent(in) :: ngrid
+  real,intent(in) :: day_ini
+  real,intent(in) :: time
+  real, intent(in) :: cell_area(ngrid) !boundaries for bining of the slopes
+  integer,intent(in) :: nslope
+  real, intent(in) :: def_slope(nslope+1) !boundaries for bining of the slopes
+  real, intent(in) :: subslope_dist(ngrid,nslope) !undermesh statistics
+
+
+  
+  ! Create physics start file
+  call open_restartphy(filename)
+  
+  ! Write the mid-layer depths
+  call put_var("soildepth","Soil mid-layer depth",mlayer_PEM)
+  
+  ! Write longitudes
+  call put_field("longitude","Longitudes of physics grid",lonfi)
+  
+  ! Write latitudes
+  call put_field("latitude","Latitudes of physics grid",latfi)
+  
+  ! Write mesh areas
+  call put_field("area","Mesh area",cell_area)
+     
+  ! Multidimensionnal variables (nogcm undermesh slope statistics)
+  call put_var("def_slope","slope criterium stages",def_slope)
+  call put_field("subslope_dist","under mesh slope distribution",subslope_dist)
+
+  call put_var("FluxGeo","Geothermal Flux (W/m^2)",fluxgeo)
+
+  ! Close file
+  call close_restartphy
+  
+end subroutine pemdem0
+
+subroutine pemdem1(filename,time,nsoil_PEM,ngrid,nslope, &
+                    tsoil_slope_PEM,inertiesoil_slope_PEM,ice_table,m_co2_regolith)
+  ! write time-dependent variable to restart file
+  use iostart_PEM, only : open_restartphy, close_restartphy, & 
+                      put_var, put_field
+
+  use comsoil_h_PEM, only: mlayer_PEM,fluxgeo,inertiedat_PEM
+                
+  implicit none
+  
+  include "callkeys.h"
+  
+  character(len=*),intent(in) :: filename
+  integer,intent(in) :: nsoil_PEM
+  integer,intent(in) :: ngrid
+  real,intent(in) :: time
+  real,intent(IN) :: tsoil_slope_PEM(ngrid,nsoil_PEM,nslope) !under mesh bining according to slope
+  real,intent(IN) :: inertiesoil_slope_PEM(ngrid,nsoil_PEM,nslope) !under mesh bining according to slope
+  real,intent(IN) :: ice_table(ngrid,nslope) !under mesh bining according to slope
+  integer,intent(IN) :: nslope
+  real,intent(in) :: m_co2_regolith(ngrid,nsoil_PEM,nslope)
+  integer :: islope
+  CHARACTER*2 :: num  
+
+ 
+  integer :: iq
+  character(len=30) :: txt ! to store some text
+  ! indexes of water vapour & water ice tracers (if any):
+
+  
+
+  ! Open file
+  call open_restartphy(filename)
+  
+  ! First variable to write must be "Time", in order to correctly
+  ! set time counter in file
+  call put_var("Time","Temps de simulation",time)
+  
+ 
+  
+  ! Multidimensionnal variables (undermesh slope statistics)
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call put_field("tsoil_PEM_slope"//num,"Soil temperature by slope type", &
+                 tsoil_slope_PEM(:,:,islope),time)
+  call put_field("TI_PEM_slope"//num,"Soil Thermal Inertia by slope type", &
+                 inertiesoil_slope_PEM(:,:,islope),time)
+
+  call put_field("mco2_reg_ads_slope"//num, "Mass of co2 adsorbded in the regolith", &
+                    m_co2_regolith(:,:,islope), time)
+
+ENDDO
+
+  call put_field("ice_table","Depth of ice table", &
+                 ice_table,time)
+
+  call put_field("inertiedat_PEM","Thermal inertie of PEM ", &
+                 inertiedat_PEM,time)
+
+
+  ! Close file
+  call close_restartphy
+  
+end subroutine pemdem1
+
+end module pemredem
